"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireWildcard(require("react"));
var _map2 = _interopRequireDefault(require("lodash/map"));
var _uikit = require("@gravity-ui/uikit");
var _cn = require("../../../helpers/cn");
var _withCollapsible = _interopRequireDefault(require("../../../hoc/withCollapsible"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var block = (0, _cn.dfCN)('labels-group');
var LabelsGroup = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(LabelsGroup, _Component);
  var _super = (0, _createSuper2.default)(LabelsGroup);
  function LabelsGroup() {
    var _this;
    (0, _classCallCheck2.default)(this, LabelsGroup);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.handleLabelClick = function (label) {
      var onClick = _this.props.onClick;
      if (typeof onClick === 'function') {
        onClick(label);
      }
    };
    _this.handleRemoveClick = function (evt, label) {
      var onRemove = _this.props.onRemove;
      evt.stopPropagation();
      if (typeof onRemove === 'function') {
        onRemove(label);
      }
    };
    return _this;
  }
  (0, _createClass2.default)(LabelsGroup, [{
    key: "renderLabel",
    value: function renderLabel(label) {
      var _this2 = this;
      var _this$props = this.props,
        onRemove = _this$props.onRemove,
        disabled = _this$props.disabled;
      var name = label.name,
        isDefault = label.isDefault;
      var onLabelClick = function onLabelClick() {
        return _this2.handleLabelClick(label);
      };
      var onRemoveClick = function onRemoveClick(evt) {
        return _this2.handleRemoveClick(evt, label);
      };
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Label, {
        className: block('label'),
        type: onRemove && !isDefault ? 'close' : 'default',
        onClick: onLabelClick,
        onClose: onRemoveClick,
        size: "s",
        disabled: disabled,
        children: name
      }, name);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        items = _this$props2.items,
        renderToggler = _this$props2.renderToggler,
        onRemoveAll = _this$props2.onRemoveAll,
        disabled = _this$props2.disabled;
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: block(),
        children: [(0, _map2.default)(items, function (label) {
          return _this3.renderLabel(label);
        }), renderToggler === null || renderToggler === void 0 ? void 0 : renderToggler(), onRemoveAll && items.length > 0 && /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Button, {
          size: "s",
          view: "flat-secondary",
          onClick: onRemoveAll,
          disabled: disabled,
          children: "Clear all"
        })]
      });
    }
  }]);
  return LabelsGroup;
}(_react.Component);
var _default = (0, _withCollapsible.default)(LabelsGroup); // #sourceMappingURL=LabelsGroup.js.map
exports.default = _default;
// #sourceMappingURL=LabelsGroup.js.map