"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireWildcard(require("react"));
var _find2 = _interopRequireDefault(require("lodash/find"));
var _findIndex2 = _interopRequireDefault(require("lodash/findIndex"));
var _uikit = require("@gravity-ui/uikit");
var _cn = require("../../helpers/cn");
var _LabelsGroup = _interopRequireDefault(require("./LabelsGroup/LabelsGroup"));
var _FocusBlurContainer = require("../FocusBlurContainer/FocusBlurContainer");
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _excluded = ["value", "onChange", "onBlur", "onFocus", "disabled"];
var block = (0, _cn.dfCN)('multi-text-control');
var MultiTextControl = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(MultiTextControl, _Component);
  var _super = (0, _createSuper2.default)(MultiTextControl);
  function MultiTextControl() {
    var _this;
    (0, _classCallCheck2.default)(this, MultiTextControl);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      currentLabel: ''
    };
    _this.updateLabel = function (text) {
      _this.setState({
        currentLabel: text
      });
    };
    _this.confirmText = function () {
      var currentLabel = _this.state.currentLabel;
      if ((currentLabel === null || currentLabel === void 0 ? void 0 : currentLabel.length) > 0) {
        var _this$props = _this.props,
          onChange = _this$props.onChange,
          labels = _this$props.value;
        if (!(0, _find2.default)(labels, function (label) {
          return label.name === currentLabel;
        })) {
          onChange(labels.concat({
            name: currentLabel
          }));
        }
        _this.setState({
          currentLabel: ''
        });
      }
    };
    _this.handleAdd = function (evt) {
      if (evt.keyCode === MultiTextControl.ENTER) {
        _this.confirmText();
      }
    };
    _this.handleClear = function () {
      _this.props.onChange(MultiTextControl.getDefaultValue());
    };
    _this.handleRemove = function (item) {
      var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        items = _this$props2.value;
      onChange(MultiTextControl.remove(item, items));
    };
    return _this;
  }
  (0, _createClass2.default)(MultiTextControl, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        labels = _this$props3.value,
        _onChange = _this$props3.onChange,
        onBlur = _this$props3.onBlur,
        onFocus = _this$props3.onFocus,
        disabled = _this$props3.disabled,
        rest = (0, _objectWithoutProperties2.default)(_this$props3, _excluded);
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_FocusBlurContainer.FocusBlurContainer, {
        className: block(),
        onBlur: onBlur,
        onFocus: onFocus,
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.TextInput, (0, _objectSpread2.default)((0, _objectSpread2.default)({
          size: "s",
          view: "normal",
          autoComplete: false,
          hasClear: true,
          disabled: disabled
        }, rest), {}, {
          onUpdate: this.updateLabel,
          onKeyDown: this.handleAdd,
          onBlur: this.confirmText,
          value: this.state.currentLabel
        })), /*#__PURE__*/(0, _jsxRuntime.jsx)(_LabelsGroup.default, {
          items: labels,
          visibleCount: 4,
          disabled: disabled,
          onRemoveAll: this.handleClear,
          onRemove: this.handleRemove
        })]
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue() {
      return [];
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(value) {
      return !value.length;
    }
  }, {
    key: "remove",
    value: function remove(theItem, items) {
      var index = (0, _findIndex2.default)(items, function (anItem) {
        return theItem.name === anItem.name;
      });
      if (index > -1) {
        var copy = (0, _toConsumableArray2.default)(items);
        copy.splice(index, 1);
        return copy;
      }
      return items;
    }
  }]);
  return MultiTextControl;
}(_react.Component);
MultiTextControl.ENTER = 13;
MultiTextControl.hasErrorRenderer = true;
var _default = MultiTextControl; // #sourceMappingURL=MultiTextControl.js.map
exports.default = _default;
// #sourceMappingURL=MultiTextControl.js.map