"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireWildcard(require("react"));
var _uikit = require("@gravity-ui/uikit");
var _cn = require("../../helpers/cn");
var _Icon = require("../Icon/Icon");
var _some = _interopRequireDefault(require("lodash/some"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var block = (0, _cn.dfCN)('dialog-tab');
var TabField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TabField, _Component);
  var _super = (0, _createSuper2.default)(TabField);
  function TabField() {
    (0, _classCallCheck2.default)(this, TabField);
    return _super.apply(this, arguments);
  }
  (0, _createClass2.default)(TabField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        tabItems = _this$props.tabItems,
        activeTab = _this$props.activeTab,
        setActiveTab = _this$props.setActiveTab,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Tabs, {
        className: className,
        items: tabItems,
        activeTab: activeTab,
        onSelectTab: setActiveTab,
        wrapTo: TabField.wrapTabItem.bind(null, onRemoveTab, onCreateTab)
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue(tabSpec) {
      return tabSpec.multiple ? [] : {};
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(value, tabSpec) {
      return tabSpec.multiple ? !value.length : !Object.keys(value).length;
    }
  }]);
  return TabField;
}(_react.Component);
TabField.isTabControl = true;
TabField.isTabControlVertical = false;
TabField.wrapTabItem = function (onRemoveTab, _onCreateTab, item, tabNode) {
  var wrapperMods = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var hasError = item.error && ('string' === typeof item.error || (0, _some.default)(item.error, function (v) {
    return Boolean(v);
  }));
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: block('wrapper', wrapperMods),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
      className: block('name'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: block('name-text'),
        children: tabNode
      }), hasError && /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: block('warning-icon'),
        title: "Some fields in this tab are not valid",
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.DangerIcon, {})
      })]
    }), item.multiple && item.removable && /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: block('remove-icon'),
      onClick: function onClick(e) {
        e.stopPropagation();
        onRemoveTab(item);
      },
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.CloseIcon, {})
    })]
  }, item.id);
};
var _default = TabField; // #sourceMappingURL=TabField.js.map
exports.default = _default;
// #sourceMappingURL=TabField.js.map