import React from 'react';
import TabField, { TabFieldProps, TabItem } from './TabField';
import { ListProps } from '@gravity-ui/uikit';
import './TabFieldVertical.scss';
declare const ITEM_HEIGHT: {
    s: number;
    m: number;
    l: number;
};
export interface TabFieldVerticalProps extends TabFieldProps {
    size?: keyof typeof ITEM_HEIGHT;
    sortable?: boolean;
    onOrderChanged?: ListProps<any>['onSortEnd'];
    wrapTo?: (node: React.ReactNode, item: TabItem) => React.ReactNode;
    virtualized?: boolean;
}
declare class TabFieldVertical extends React.Component<TabFieldVerticalProps> {
    static defaultProps: {
        size: "s" | "m" | "l";
    };
    static isTabControl: true;
    static isTabControlVertical: boolean;
    static getDefaultValue: typeof TabField.getDefaultValue;
    static isEmpty: typeof TabField.isEmpty;
    onItemClick: (item: TabItem) => void;
    renderItem: (item: TabItem) => string | number | boolean | React.JSX.Element | Iterable<React.ReactNode> | null | undefined;
    render(): React.JSX.Element;
}
export default TabFieldVertical;
