"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withCollapsible;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));
var _react = _interopRequireDefault(require("react"));
var _uikit = require("@gravity-ui/uikit");
var _utils = require("./utils");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function withCollapsible(Component) {
  var _class;
  var ResultComponent = (_class = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2.default)(WithCollapsible, _React$Component);
    var _super = (0, _createSuper2.default)(WithCollapsible);
    function WithCollapsible(props) {
      var _this;
      (0, _classCallCheck2.default)(this, WithCollapsible);
      _this = _super.call(this, props);
      _this.state = {
        collapsed: true
      };
      _this.handleToggle = function () {
        return _this.setState(function (prevState) {
          return {
            collapsed: !prevState.collapsed
          };
        });
      };
      _this.renderToggler = function () {
        var _this$props = _this.props,
          items = _this$props.items,
          visibleCount = _this$props.visibleCount;
        var collapsed = _this.state.collapsed;
        var hasToggler = items.length > visibleCount;
        var resCount = items.length - visibleCount;
        return hasToggler && /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Button, {
          size: "s",
          view: "flat",
          onClick: _this.handleToggle,
          children: collapsed ? "Show more (".concat(resCount, ")") : 'Show less'
        });
      };
      _this.state = {
        collapsed: !props.initialExpanded
      };
      if (props.renderToggler) {
        console.warn('"renderToggler" property will be overriden');
      }
      return _this;
    }
    (0, _createClass2.default)(WithCollapsible, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/(0, _jsxRuntime.jsx)(Component, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, this.props), {}, {
          items: this.getItems(),
          renderToggler: this.renderToggler
        }));
      }
    }, {
      key: "getItems",
      value: function getItems() {
        var visibleCount = this.getVisibleItemsCount();
        var items = this.props.items;
        return visibleCount < items.length ? items.slice(0, visibleCount) : items;
      }
    }, {
      key: "getVisibleItemsCount",
      value: function getVisibleItemsCount() {
        var _this$props2 = this.props,
          items = _this$props2.items,
          visibleCount = _this$props2.visibleCount;
        var collapsed = this.state.collapsed;
        return collapsed && items.length > visibleCount ? visibleCount : items.length;
      }
    }]);
    return WithCollapsible;
  }(_react.default.Component), _class.displayName = "WithCollapsible(".concat((0, _utils.getDisplayName)(Component), ")"), _class);
  return ResultComponent;
}
// #sourceMappingURL=withCollapsible.js.map
// #sourceMappingURL=withCollapsible.js.map